"use strict";Object.defineProperty(exports, "__esModule", {value: true});











var _chunkC3GKUYHBcjs = require('./chunk-C3GKUYHB.cjs');














var _chunkGO4CGN66cjs = require('./chunk-GO4CGN66.cjs');


var _chunk5KZAXCCXcjs = require('./chunk-5KZAXCCX.cjs');


var _chunkQP5Y3I6Fcjs = require('./chunk-QP5Y3I6F.cjs');

// src/common/bin/index.ts
var BinaryEncoder = class {
  async encode(data) {
    const dataEncoder = _chunkGO4CGN66cjs.createBinEncoder.call(void 0, );
    _chunkGO4CGN66cjs.writeAny.call(void 0, dataEncoder, data);
    return _chunkGO4CGN66cjs.encodeToUint8Array.call(void 0, dataEncoder);
  }
  async decode(data) {
    return _chunkC3GKUYHBcjs.readAny.call(void 0, _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, data)));
  }
};
function encodeJson(data) {
  const dataEncoder = _chunkGO4CGN66cjs.createBinEncoder.call(void 0, );
  _chunkGO4CGN66cjs.writeAny.call(void 0, dataEncoder, data);
  return _chunkGO4CGN66cjs.encodeToUint8Array.call(void 0, dataEncoder);
}
function decodeJson(data) {
  return _chunkC3GKUYHBcjs.readAny.call(void 0, _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, data)));
}
function createBinaryStreamEncoder(initialData) {
  const dataEncoder = _chunkGO4CGN66cjs.createBinEncoder.call(void 0, );
  if (initialData != null)
    _chunkGO4CGN66cjs.writeUint8Array.call(void 0, dataEncoder, _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, initialData));
  return {
    /** Just writes the bytes. Length is not stored! */
    writeBytes: (data, expectedLength) => {
      const bin = _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, data);
      _chunk5KZAXCCXcjs.assertCondition.call(void 0, !(expectedLength != null && bin.length !== expectedLength), `Expected ${expectedLength} bytes, got ${bin.length}`);
      _chunkGO4CGN66cjs.writeUint8Array.call(void 0, dataEncoder, bin);
    },
    writeBytesVar: (data) => _chunkGO4CGN66cjs.writeVarUint8Array.call(void 0, dataEncoder, _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, data)),
    writeUintVar: (data) => _chunkGO4CGN66cjs.writeVarUint.call(void 0, dataEncoder, data),
    writeUint8: (data) => _chunkGO4CGN66cjs.writeUint8.call(void 0, dataEncoder, data),
    writeUint16: (data) => _chunkGO4CGN66cjs.writeUint16.call(void 0, dataEncoder, data),
    writeUint32: (data) => _chunkGO4CGN66cjs.writeUint32.call(void 0, dataEncoder, data),
    writeIntVar: (data) => _chunkGO4CGN66cjs.writeVarInt.call(void 0, dataEncoder, data),
    writeFloat: (data) => _chunkGO4CGN66cjs.writeFloat32.call(void 0, dataEncoder, data),
    writeStringVar: (data) => _chunkGO4CGN66cjs.writeVarString.call(void 0, dataEncoder, data),
    write: (data) => _chunkGO4CGN66cjs.writeAny.call(void 0, dataEncoder, data),
    getUint8Array: () => _chunkGO4CGN66cjs.encodeToUint8Array.call(void 0, dataEncoder),
    getLength: () => _chunkGO4CGN66cjs.length.call(void 0, dataEncoder)
  };
}
function createBinaryStreamDecoder(data) {
  const dataDecoder = _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, data));
  return {
    readBytes: (len) => _chunkC3GKUYHBcjs.readUint8Array.call(void 0, dataDecoder, len),
    readBytesVar: () => _chunkC3GKUYHBcjs.readVarUint8Array.call(void 0, dataDecoder),
    readUintVar: () => _chunkC3GKUYHBcjs.readVarUint.call(void 0, dataDecoder),
    readUint8: () => _chunkC3GKUYHBcjs.readUint8.call(void 0, dataDecoder),
    readUint16: () => _chunkC3GKUYHBcjs.readUint16.call(void 0, dataDecoder),
    readUint32: () => _chunkC3GKUYHBcjs.readUint32.call(void 0, dataDecoder),
    readIntVar: () => _chunkC3GKUYHBcjs.readVarInt.call(void 0, dataDecoder),
    readFloat: () => _chunkC3GKUYHBcjs.readFloat32.call(void 0, dataDecoder),
    readStringVar: () => _chunkC3GKUYHBcjs.readVarString.call(void 0, dataDecoder),
    read: () => _chunkC3GKUYHBcjs.readAny.call(void 0, dataDecoder),
    getOffset: () => dataDecoder.pos || 0
  };
}
function bitfield(bitfield2 = 0) {
  return {
    setBit: (bit, value = true) => value ? bitfield2 |= 1 << bit : bitfield2 &= ~(1 << bit),
    unsetBit: (bit) => bitfield2 &= 1 << bit,
    toggleBit: (bit) => bitfield2 ^= 1 << bit,
    getBit: (bit) => (bitfield2 & 1 << bit) !== 0,
    getValue: () => bitfield2
  };
}
async function blobToArrayBuffer(blob) {
  return await blob.arrayBuffer();
}
async function blobToUint8Array(blob) {
  const buffer = await blobToArrayBuffer(blob);
  if (buffer != null)
    return _chunkQP5Y3I6Fcjs.toUint8Array.call(void 0, buffer);
}










exports.BinaryEncoder = BinaryEncoder; exports.encodeJson = encodeJson; exports.decodeJson = decodeJson; exports.createBinaryStreamEncoder = createBinaryStreamEncoder; exports.createBinaryStreamDecoder = createBinaryStreamDecoder; exports.bitfield = bitfield; exports.blobToArrayBuffer = blobToArrayBuffer; exports.blobToUint8Array = blobToUint8Array;
//# sourceMappingURL=chunk-4S7DC4SP.cjs.map